﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using C1.Silverlight.Chart;
using C1.Silverlight;

namespace Chart_ContextMenu
{
    public partial class MainPage : UserControl
    {        
        C1.Silverlight.C1ContextMenu menu;

        public MainPage()
        {
            InitializeComponent();

            foreach (DataSeries ds in _chart.Data.Children)
                ds.PlotElementLoaded += new EventHandler(ds_PlotElementLoaded);

            C1.Silverlight.C1ContextMenu menu;
            menu = new C1.Silverlight.C1ContextMenu();
            C1MenuItem menuitem = new C1MenuItem();
            menuitem.Header = "BackGround";
            menuitem.Click += new EventHandler<SourcedEventArgs>(menuitem_Click);
            menu.Items.Add(menuitem);

            menuitem = new C1MenuItem();
            menuitem.Header = "Reset Background";
            menuitem.Visibility = System.Windows.Visibility.Collapsed;
            menuitem.Click +=new EventHandler<SourcedEventArgs>(menuitem_Click);
            menu.Items.Add(menuitem);

            _chart.MouseRightButtonDown += new MouseButtonEventHandler(_chart_MouseRightButtonDown);
        }

        void menuitem_Click(object sender, SourcedEventArgs e)
        {            
            C1MenuItem currMenu = sender as C1MenuItem;

            if (currMenu.Header.ToString() == "BackGround")
            {
                if (currentPE != null)
                {
                    (currentPE.Content as Path).Tag = (currentPE.Content as Path).Fill;
                    (currentPE.Content as Path).Fill = new SolidColorBrush(Colors.Gray);
                }
            }
            else
            {
                (currentPE.Content as Path).Fill = (currentPE.Content as Path).Tag as SolidColorBrush;
                (currentPE.Content as Path).Tag = null;
            }
        }        

        /// <summary>
        /// Cancel the Default Silverlight Menu from Chart Object
        /// </summary>        
        void _chart_MouseRightButtonDown(object sender, MouseButtonEventArgs e)
        {
            e.Handled = true;
        }

        void ds_PlotElementLoaded(object sender, EventArgs e)
        {
            (sender as PlotElement).MouseRightButtonDown += new MouseButtonEventHandler(PlotElement_MouseRightButtonDown);
            (sender as PlotElement).MouseRightButtonUp += new MouseButtonEventHandler(PlotElement_MouseRightButtonUp);  
        }

        // Holds reference to currently selected PlotElement Object        
        PlotElement currentPE;

        /// <summary>
        /// 1. Cancel the default Silverlight ContextMenu
        /// 2. Stores the reference of current PlotElement in variable 'currentPE
        /// </summary>        
        void PlotElement_MouseRightButtonDown(object sender, MouseButtonEventArgs e)
        {
            currentPE = sender as PlotElement;
            e.Handled = true;            
        }

        /// <summary>
        /// Toggles the visibility of MenuItems based on the current
        /// background applied on the PlotElement
        /// </summary>        
        void PlotElement_MouseRightButtonUp(object sender, MouseButtonEventArgs e)  
        {
            if (currentPE != (sender as PlotElement))
                return;
            
            if ((currentPE.Content as Path).Tag != null)
            {
                (menu.Items[0] as C1MenuItem).Visibility = System.Windows.Visibility.Collapsed;
                (menu.Items[1] as C1MenuItem).Visibility = System.Windows.Visibility.Visible;
            }
            else
            {
                (menu.Items[0] as C1MenuItem).Visibility = System.Windows.Visibility.Visible;
                (menu.Items[1] as C1MenuItem).Visibility = System.Windows.Visibility.Collapsed;            
            }

            menu.Show(currentPE,e.GetPosition(currentPE));
        }
    }
}
